#include <iostream>
#include <sstream>
#include "generator.hpp"
#include "../graph/bipartite_graph/bip_graph_io.hpp"

void usage(const char* name)
{
    std::cout << "usage: " << name << " <fixedsize> <freesize> <numedges> [seed]" << std::endl;
}

template <typename T, typename Istream = decltype((std::cin))>
T parse(const char* errmsg = "", Istream&& is = std::cin)
{
    T x;
    if (!(is >> x))
        throw std::runtime_error(errmsg);
    return x;
}


int main(int argc, char* argv[])
{
    if (argc < 4) {
        usage(argv[0]);
        return 0;
    }
    try {
        using ss = std::stringstream;
        auto fixed_size = parse<size_t>("could not read fixed size", ss(argv[1]));
        auto free_size = parse<size_t>("could not read free size", ss(argv[2]));
        auto num_edges = parse<size_t>("could not read num edges", ss(argv[3]));
        unsigned long seed = 42;
        if (argc >= 5)
            seed = parse<unsigned long>("could not read seed", ss(argv[4]));
        bip_graph_generator gen(seed);
        auto g = gen.gen_graph(fixed_size, free_size, num_edges);
        output_bip_graph_pace(g, std::cout, "random graph generated by goat solver");
    }
    catch (std::exception& e) {
        std::cout << "Exception: " << e.what() << std::endl;
        return 1;
    }
    return 0;
}